<template>
  <section id="new-form" class="py-4">
    <h1 class="">
      <input
        type="text"
        v-model="form.title"
        class="font-bold text-primary text-xl bg-transparent"
      />
    </h1>
    <p class="text-secondary text-xs">#{{ uid }}</p>
    <div class="grid grid-cols-6 gap-8 mt-4">
      <div class="col-span-2">
        <div class="border-b-2 border-secondary">
          <div class="grid grid-cols-2 gap-4 mb-4">
            <div
              v-for="t in types"
              :key="t.label"
              class="cursor-pointer hover:text-light transition duration-300 bg-secondary hover:bg-primary text-primary text-center py-2 text-sm rounded-md"
              @click="addItem(t)"
            >
              Add {{ t.btn_label }}
            </div>
          </div>
        </div>
        <div class="mt-2">
          <div>
            <p class="font-semibold mb-2">Target :</p>
            <input
              type="text"
              placeholder="https://"
              class="px-2 py-2 w-full rounded-md"
              v-model="form.target"
            />
          </div>
          <div class="mt-2">
            <p class="font-semibold mb-2">Headers :</p>
            <div>
              <div
                v-for="(h, index) in form.headers"
                :key="'key_' + index"
                class="grid grid-cols-2 gap-4 my-2"
              >
                <div>
                  <input
                    placeholder="Key"
                    v-model="h.key"
                    class="px-2 py-1 rounded-md w-full"
                  />
                </div>
                <div>
                  <input
                    placeholder="Value"
                    v-model="h.value"
                    class="px-2 py-1 rounded-md w-full"
                  />
                </div>
              </div>
            </div>
            <div class="mt-4">
              <div
                class="border-2 border-secondary hover:bg-primary hover:text-white transition duration-300 w-32 text-center rounded-md py-1 text-sm cursor-pointer"
                @click="addHeader()"
              >
                Add headers
              </div>
            </div>
          </div>
        </div>
      </div>
      <div class="col-span-4">
        <div
          id="items"
          class="grid grid-cols-1 gap-4 border-2 border-secondary rounded-md p-4"
        >
          <div
            v-for="(item, index) in form.properties"
            :key="`form_${index}`"
            class="relative cursor-move bg-gray-50 rounded-md p-2"
          >
            <div
              class="absolute top-3 right-2 z-50 cursor-pointer hover:text-red-900 transition duration-300"
              @click="removeItem(index)"
            >
              <svg
                xmlns="http://www.w3.org/2000/svg"
                class="h-6 w-6"
                fill="none"
                viewBox="0 0 24 24"
                stroke="currentColor"
                stroke-width="2"
              >
                <path
                  stroke-linecap="round"
                  stroke-linejoin="round"
                  d="M10 14l2-2m0 0l2-2m-2 2l-2-2m2 2l2 2m7-2a9 9 0 11-18 0 9 9 0 0118 0z"
                />
              </svg>
            </div>

            <input
              v-if="item.display !== 'separator' && item.display !== 'title'"
              class="text-sm text-gray-500 mb-2 w-1/2 px-2 py-1 rounded-md"
              v-model="item.label"
            />

            <div
              v-if="item.display === 'separator'"
              class="border-b-2 border-secondary"
            ></div>

            <div v-if="item.display === 'input'">
              <input
                :type="item.type"
                v-model="item.value"
                :placeholder="item.placeholder"
                class="p-2 w-full rounded-md"
              />
            </div>
            <div v-else-if="item.display === 'textarea'">
              <textarea
                v-model="item.value"
                :placeholder="item.placeholder"
                class="p-2 w-full h-full"
              />
            </div>
            <div v-else-if="item.display === 'title'">
              <input
                :type="item.type"
                class="text-2xl font-bold bg-transparent px-2 w-3/4"
                :placeholder="item.placeholder"
                v-model="item.value"
              />
            </div>
            <div v-else>
              {{ item.placeholder }}
            </div>
            <div
              v-if="item.display === 'input' || item.display === 'textarea'"
              class="text-secondary text-xs px-2 mt-2"
            >
              Placeholder:
              <input
                class="text-xs text-gray-500 mb-1 bg-gray-0 rounded-sm px-1"
                v-model="item.placeholder"
              />
            </div>
            <div class="text-secondary text-xs px-2 mt-2">
              ID:
              <input
                class="text-xs text-gray-500 mb-1 bg-gray-0 rounded-sm px-1"
                v-model="item.key"
              />
            </div>
          </div>
        </div>
        <div class="mt-4">
          <h2 class="font-bold text-sm">JSON :</h2>
          <div
            class="bg-primary text-green-400 p-4 rounded-md text-sm cursor-pointer max-h-96 overflow-y-auto text-left"
            @click="copyJson(form)"
          >
            <pre>{{ form }}</pre>
          </div>
          <div class="mt-4 text-center">
            <a
              class="bg-primary w-48 mx-auto py-2 px-4 text-lg text-light text-center rounded-md cursor-pointer shadow-xl hover:shadow-none transition duration-300"
              :href="`data:text/json;charset=utf-8,${encodeURIComponent(
                JSON.stringify(form)
              )}`"
              :download="`${form.id}.json`"
            >
              Download JSON
            </a>
          </div>
        </div>
      </div>
    </div>
  </section>
</template>
<script>
import Sortable from 'sortablejs'
export default {
  async asyncData({ store }) {
    const uid = await store.dispatch('getUid')
    return { uid }
  },
  mounted() {
    if (this.$route.query.edit) {
      JSON.parse(localStorage.getItem('forms')).filter((form) => {
        if (form.id === this.$route.query.edit) {
          this.formModel = form
          this.uid = form.id
        }
      })
    }

    let t = this
    let el = document.getElementById('items')
    let sortable = Sortable.create(el, {
      onChange: function (evt) {
        console.log(evt)
        t.arraymove(t.form.properties, evt.oldIndex, evt.newIndex)
        evt.newIndex
      },
    })
  },
  data() {
    return {
      uid: null,
      types: [
        {
          key: 'title',
          label: 'Title label',
          btn_label: 'Title',
          type: 'text',
          display: 'title',
          placeholder: 'Set your title',
          value: null,
        },
        {
          key: 'text',
          label: 'Text field label',
          btn_label: 'Text field',
          type: 'text',
          display: 'input',
          placeholder: 'Feed your text field',
          value: null,
        },
        {
          key: 'textarea',
          label: 'Textarea label',
          btn_label: 'Textarea',
          type: 'textarea',
          display: 'textarea',
          placeholder: 'Feed your textarea',
          value: null,
        },
        {
          key: 'number',
          label: 'Number field label',
          btn_label: 'Number field',
          type: 'number',
          display: 'input',
          placeholder: 'Set a number',
          value: null,
        },
        {
          key: 'phone',
          label: 'Phone field label',
          btn_label: 'Phone field',
          type: 'tel',
          display: 'input',
          placeholder: 'Set a phone number',
          value: null,
        },
        {
          key: 'email',
          label: 'Email field label',
          btn_label: 'Email field',
          type: 'email',
          display: 'input',
          placeholder: 'Set an email',
          value: null,
        },
        {
          key: 'time',
          label: 'Time field label',
          btn_label: 'Time field',
          type: 'time',
          display: 'input',
          placeholder: 'Set a time',
          value: null,
        },
        {
          key: 'date',
          label: 'Date field label',
          btn_label: 'Date field',
          type: 'date',
          display: 'input',
          placeholder: 'Set a date',
          value: null,
        },
        {
          key: 'datetime',
          label: 'Datetime field label',
          btn_label: 'Datetime field',
          type: 'datetime-local',
          display: 'input',
          placeholder: 'Set a datetime',
          value: null,
        },
        {
          key: 'separator',
          label: 'separator',
          btn_label: 'Separator',
          display: 'separator',
        },
      ],
      formModel: {
        id: this.id,
        title: 'My new form',
        target: '',
        headers: [
          {
            key: 'Content-Type',
            value: 'application/json',
          },
        ],
        properties: [],
      },
    }
  },
  computed: {
    id() {
      return this.uid
    },
    form() {
      return this.formModel
    },
  },
  methods: {
    async addItem(obj) {
      const id = await this.$store.dispatch('getInputId')
      obj.key = `${id}`
      const item = Object.assign({}, obj)
      this.form.properties.push(item)
      return
    },
    async addHeader() {
      this.form.headers.push({
        key: '',
        value: '',
      })
    },
    arraymove(arr, fromIndex, toIndex) {
      var element = arr[fromIndex]
      arr.splice(fromIndex, 1)
      arr.splice(toIndex, 0, element)
    },
    removeItem(index) {
      this.form.properties.splice(index, 1)
    },
    async copyJson(data) {
      try {
        const rawData = JSON.stringify(data)
        await navigator.clipboard.writeText(rawData)
        alert('JSON copié dans le presse-papier.')
      } catch (error) {
        console.log(error)
      }
    },
  },
  watch: {
    form: {
      handler() {
        console.log('formModel', this.formModel)
        this.formModel.id = this.id
        let form = JSON.parse(localStorage.getItem('forms')) || []

        if (form.length > 0) {
          form = form.map((item) => {
            if (item?.id === this.form.id) {
              item = this.formModel
            }
            return item
          })
        }
        form.filter((item) => item?.id === this.form.id).length === 0
          ? form.push(this.formModel)
          : null

        localStorage.setItem('forms', JSON.stringify(form))
      },
      deep: true,
    },
  },
}
</script>
